req = {}
function getTableName(tbl) -- http://www.computercraft.info/forums2/index.php?/topic/5187-lua-solved-table-name/
	for k, v in pairs(_G) do
		if v == tbl then
			return k
		end
	end
	return nil
end

function gettable(t) -- specialized version of table to string.
	local str = getTableName(t).." = {"
	if t[1] == nil then return str.."}" else
	for i = 1, #t-1 do
		str = str.."'"..t[i].."', "
	end
	return str.."'"..t[#t].."'".."}"
	end
end

logdir = "sys/lua/vaclog.txt"
vaclistdir = "sys/lua/vaclist.lua"

local file = io.open(vaclistdir, "r")
if file then
	file:close()
	dofile(vaclistdir)
else
	vacbanlist = {}
	local file = io.open(vaclistdir, "w")
	file:write(gettable(vacbanlist))
	file:close()
end

addhook("httpdata", "_httpdata")
addhook("join", "_join")
addhook("team", "_team")
addhook("shutdown", "_shutdown")

logusgn = true -- true for logging vac banned players' usgn
allow_play = false -- true for letting vac banned players to participate in the game.
kick_player = true -- true for kicking vac banned players

function _team(p, t)
	if t ~= 0 then
		if player(p, "steamid") == "0" then
			msg2(p, "You must log in to steam in order to play!")
			return 1
		else
			for i = 1, #vacbanlist do
				if vacbanlist[i] == player(p, "steamid") and not allow_play then
					msg2(p, "This server does not allow you to play because you have VAC bans record!")
					return 1
				end
			end
		end
	end
end

function _join(p)
	req[#req] = {}
	req[#req][1] = p
	if player(p, "steamid") ~= "0" then
		local found = false -- yes, good old kiddo approach
		for i = 1, #vacbanlist do
			if player(p, "steamid") == vacbanlist[i] then found = true vac(p) break end
		end
		if not found then req[#req][2] = reqhttp("steamcommunity.com", "/profiles/"..player(p, "steamid").."?xml=1", 0) end
	end
end

if logusgn then function logplayer(p)
	if player(p, "usgn") > 0 then
		local f = io.open(logdir, "a")
		f:write(player(p, "usgn").."\n")
		f:close()
	end
end
end

function vac(p)
	if logusgn then logplayer(p) end
	if allow_play then msg("Warning! "..player(p, "name").." has VAC ban in record!") end
	if kick_player then
		msg(player(p, "name").." has VAC ban in record! Kicked!")
		parse("kick "..p.."\'VAC ban in record'")
	end
end

function compareandadd(x, y)
	for i = 1, #x do
		if x[i] == y then return end
	end
	table.insert(x, #x, y)
end

function _httpdata(r, s, d)
	for i = 0, #req do
		if req[i][2] == r then
			if s == 1 then
				local a = string.find(d, "<vacBanned>") + 11
				if d:sub(a, a) == "1" then -- if a vac ban has been issued to the player, regardless of the time
					compareandadd(vacbanlist, player(req[i][1], "steamid"))
					vac(req[i][1])
				end
			else
				print("ERROR! DID NOT RECEIVE DATA FROM STEAM!")
			end
			break
		end
	end
end

function _shutdown() -- save vacbanlist when server shuts down so that the server can load it next time.
	local file = io.open(vaclistdir, "w")
	file:write(gettable(vacbanlist))
	file:close()
end